      SUBROUTINE SYMVRT(A,S,KN,N)
!---------------------------------------------------------------------
! $ SUBROUTINE SYMVRT(A,S,KN,N)                   (BTR)
! $ INVERTS SYMMETRIC MATRIX
! $ A = (R) INPUT  INPUT MATRIX
! $ S = (R) OUTPUT  OUTPUT MATRIX
! $ KN = (I) INPUT  NUMBER OF ROWS IN MATRICES
! $ N = (I) INPUT  NUMBER OF COLUMNS IN MATRICES
! $$ SYMVRT = VAS,UTILITY
!---------------------------------------------------------------------
       INTEGER KN,N,J,I,IM,l,NM,II,K,JM,JP,IP	
      REAL*8 A(KN,KN),S(KN,KN),SUM
      S(1,1)=1.0D0/A(1,1)
      IF(N-1)110,110,120
  110 RETURN
  120 DO 130 J=2,N
      S(1,J)=A(1,J)
  130 CONTINUE
!      WRITE(*,'('' FINISHING LOOP 130 !'')')
      DO 160 I=2,N
      IM=I-1
      DO 150 J=I,N
      SUM=0.0D0
      DO 140 L=1,IM
      SUM=SUM+S(L,I)*S(L,J)*S(L,L)
  140 CONTINUE
      S(I,J)=A(I,J)-SUM
  150 CONTINUE
!      WRITE(*,'('' I & SUM : '',I4,1X,D15.2)') I,SUM
      S(I,I)=1.0D0/S(I,I)
  160 CONTINUE
!      WRITE(*,'('' FINISHING LOOP 160 !'')')
      DO 170 I=2,N
      IM=I-1
      DO 170 J=1,IM
  170 S(I,J)=0.0D0
!      WRITE(*,'('' FINISHING LOOP 170 !'')')
      NM=N-1
      DO 180 II=1,NM
      IM=N-II
      I=IM+1
      DO 180 J=1,IM
      SUM=S(J,I)*S(J,J)
      DO 180 K=I,N
      S(K,J)=S(K,J)-S(K,I)*SUM
  180 CONTINUE
!      WRITE(*,'('' FINISHING LOOP 180 !'')')
      DO 210 J=2,N
      JM=J-1
      JP=J+1
      DO 210 I=1,JM
      S(I,J)=S(J,I)
      IF(JP-N)190,190,210
  190 DO 200 K=JP,N
      S(I,J)=S(I,J)+S(K,I)*S(K,J)/S(K,K)
  200 CONTINUE
  210 CONTINUE
!      WRITE(*,'('' FINISHING LOOP 210 !'')')
      DO 250 I=1,N
      IP=I+1
      SUM=S(I,I)
      IF(IP-N)220,220,240
  220 DO 230 K=IP,N
      SUM=SUM+S(K,I)*S(K,I)/S(K,K)
  230 CONTINUE
  240 S(I,I)=SUM
  250 CONTINUE
!      WRITE(*,'('' FINISHING LOOP 250 !'')')
      DO 260 I=1,N
      DO 260 J=I,N
      S(J,I)=S(I,J)
  260 CONTINUE
      RETURN
      END
